package rasmus_torkel.test.misc;

import java.io.File;
import java.io.FileWriter;

import rasmus_torkel.misc.FileUtil;
import rasmus_torkel.test_framework.UnitTest;

public class FileUtilVerifyForCreationTest extends UnitTest
{
    public static void
    main(String[] args)
    {
        announceTestClassStart(FileUtilVerifyForCreationTest.class);
        printArgs(args);
        for (String fileName : args)
        {
            doOne(fileName);
        }
    }
    
    public static void
    doOne(String fileName)
    {
        System.out.println("Doing " + fileName);
        File file = new File(fileName);
        printTestPartSeparator();
        System.out.println("new FileWriter");
        try
        {
            FileWriter writer = new FileWriter(file);
            System.out.println("Success");
            writer.close();
        }
        catch (Exception e)
        {
            System.out.println(e.toString());
        }
        printTestPartSeparator();
        System.out.println("FileUtil.makeFileWriter");
        try
        {
            FileWriter writer = FileUtil.makeFileWriter(file);
            System.out.println("Success");
            writer.close();
        }
        catch (Exception e)
        {
            System.out.println(e.toString());
        }
        printEndTest();
    }
}
