package rasmus_torkel.test.misc;

import rasmus_torkel.misc.IntUtil;
import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.test_framework.UnitTestError;

public class IntUtilTester extends UnitTest
{
    public static void
    main(String[] args)
    {
        testZeroPad(0, 0, "0");
        testZeroPad(0, 1, "0");
        testZeroPad(0, 2, "00");
        testZeroPad(1, 1, "1");
        testZeroPad(2, 2, "02");
        testZeroPad(9, 2, "09");
        testZeroPad(10, 2, "10");
        testZeroPad(999, 2, "999");
        testZeroPad(999, 3, "999");
        testZeroPad(999, 4, "0999");
        testZeroPad(999, 5, "00999");
        testZeroPad(1000, 2, "1000");
        testZeroPad(1000, 3, "1000");
        testZeroPad(1000, 4, "1000");
        testZeroPad(1000, 5, "01000");
        testZeroPad(Integer.MAX_VALUE, 9, "" + Integer.MAX_VALUE);
        testZeroPad(Integer.MAX_VALUE, 10, "" + Integer.MAX_VALUE);
        testZeroPad(Integer.MAX_VALUE, 11, "0" + Integer.MAX_VALUE);
        testZeroPad(-1, 4, "-001");
        testToHex(0x0, "00000000");
        testToHex(0x1, "00000001");
        testToHex(0x01234567, "01234567");
        testToHex(0x76543210, "76543210");
        testToHex(0x7FFFFFFE, "7FFFFFFE");
        testToHex(0x7FFFFFFF, "7FFFFFFF");
        testToHex(0x80000000, "80000000");
        testToHex(0x80000001, "80000001");
        testToHex(0x89ABCDEF, "89ABCDEF");
        testToHex(0xFEDCBA98, "FEDCBA98");
        testToHex(0xFFFFFFFE, "FFFFFFFE");
        testToHex(0xFFFFFFFF, "FFFFFFFF");
    }
    
    public static void
    testZeroPad(int    n,
                int    desiredLength,
                String expectedS)
    {
        System.out.println("IntUtil.zeroPad(" + n + ", " + desiredLength + ")");
        String s = IntUtil.zeroPad(n, desiredLength);
        System.out.println("Got " + s);
        if (!s.equals(expectedS))
        {
            System.out.println("Expected " + expectedS);
            throw new UnitTestError(IntUtilTester.class);
        }
        printEndTest();
    }
    
    public static void
    testToHex(int    n,
              String expectedHex)
    {
        String hex = IntUtil.toHexUpper(n);
        System.out.println("testToHex: " + n + " -> " + hex);
        if (!hex.equals(expectedHex))
        {
            System.out.println("Expected " + expectedHex);
            throw new UnitTestError();
        }
    }
}
