/*
 * Copyright Rasmus Torkel 2013
 * Author    Rasmus Torkel 2012/2013
 * 
 * You may only use this software subject to the terms and conditions which either you or your
 * organisation would have downloaded with this software and which should have been placed
 * somewhere accessible to you. These conditions are likely to
 * -- allow you or your organisation to determine whether you or your organisation
 *    may use this software for free or not and if not how to pay and how much;
 * -- prohibit or restrict republishing of this software and transmission to other organisations,
 *    even related companies within the same group;
 * -- prohibit the renaming of this class and the containing package.
 *    
 * Neither you nor your organisation may modify this header. However, you or your organisation
 * may modify anything below this header. If so, you or your organisation must place a comment
 * to that effect immediately below this header.
 */
package rasmus_torkel.test.set.chars;

import rasmus_torkel.set.chars.CharSet;
import rasmus_torkel.set.chars.DefinedCharSets;

public class CharSetDisplayAllTest
{
    public static void
    displayAll(CharSet charSet)
    {
        System.out.println();
        System.out.println("label = " + charSet._label);
        System.out.println("max = " + charSet._max);
        System.out.println("bitQty = " + charSet._bitQty);
        int charQty = 0;
        for (int chi = 0; chi < Character.MAX_VALUE; chi++)
        {
            char ch = (char)chi;
            if (charSet.isIn(ch))
            {
                System.out.println("  character with hex value " + Integer.toHexString(chi) + " is in");
                charQty++;
            }
        }
        System.out.println(charQty + " characters");
    }
    
    public static void
    main(String[] args)
    {
        displayAll(DefinedCharSets.BITS_8_NON_NULL);
        displayAll(DefinedCharSets.BITS_7_NON_NULL);
    }
}
