package rasmus_torkel.test.set.ints;

import rasmus_torkel.set.ints.AllInts;
import rasmus_torkel.set.ints.IntRange;
import rasmus_torkel.set.ints.IntSet;
import rasmus_torkel.test_framework.UnitTest;

public class IntSetsTest extends UnitTest
{
    private void
    test(int     value,
         IntSet  set,
         boolean expectIn)
    {
        boolean isIn = set.isIn(value);
        if (isIn)
        {
            System.out.println(value + " is in IntSet " + set);
        }
        else
        {
            System.out.println(value + " is out of IntSet " + set);
        }
        if (isIn != expectIn)
        {
            fail("expectIn = " + expectIn);
        }
    }
    
    public static void
    main(String[] args)
    {
        IntSetsTest t = new IntSetsTest();
        t.test();
    }
    
    public void
    test()
    {
        announceTestClassStart();
        test(Integer.MIN_VALUE, IntRange.ALL_BYTES, false);
        test(Short.MIN_VALUE, IntRange.ALL_BYTES, false);
        test(Byte.MIN_VALUE - 1, IntRange.ALL_BYTES, false);
        test(Byte.MIN_VALUE, IntRange.ALL_BYTES, true);
        test(-1, IntRange.ALL_BYTES, true);
        test(0, IntRange.ALL_BYTES, true);
        test(1, IntRange.ALL_BYTES, true);
        test(Byte.MAX_VALUE, IntRange.ALL_BYTES, true);
        test(Byte.MAX_VALUE + 1, IntRange.ALL_BYTES, false);
        test(Short.MAX_VALUE, IntRange.ALL_BYTES, false);
        test(Integer.MAX_VALUE, IntRange.ALL_BYTES, false);
        
        printTestPartSeparator();
        test(Integer.MIN_VALUE, IntRange.ALL_SHORTS, false);
        test(Short.MIN_VALUE - 1, IntRange.ALL_SHORTS, false);
        test(Short.MIN_VALUE, IntRange.ALL_SHORTS, true);
        test(Byte.MIN_VALUE, IntRange.ALL_SHORTS, true);
        test(-1, IntRange.ALL_SHORTS, true);
        test(0, IntRange.ALL_SHORTS, true);
        test(1, IntRange.ALL_SHORTS, true);
        test(Byte.MAX_VALUE, IntRange.ALL_SHORTS, true);
        test(Short.MAX_VALUE, IntRange.ALL_SHORTS, true);
        test(Short.MAX_VALUE + 1, IntRange.ALL_SHORTS, false);
        test(Integer.MAX_VALUE, IntRange.ALL_SHORTS, false);
        
        printTestPartSeparator();
        test(Integer.MIN_VALUE, AllInts.INSTANCE, true);
        test(-1, AllInts.INSTANCE, true);
        test(0, AllInts.INSTANCE, true);
        test(1, AllInts.INSTANCE, true);
        test(Integer.MAX_VALUE, AllInts.INSTANCE, true);
        
        announceTestClassPass();
    }
}
