package rasmus_torkel.test.set.longs;

import rasmus_torkel.set.longs.AllLongs;
import rasmus_torkel.set.longs.LongRange;
import rasmus_torkel.set.longs.LongSet;
import rasmus_torkel.test_framework.UnitTest;

public class LongSetsTest extends UnitTest
{
    private void
    test(long    value,
         LongSet set,
         boolean expectIn)
    {
        boolean isIn = set.isIn(value);
        if (isIn)
        {
            System.out.println(value + " is in LongSet " + set);
        }
        else
        {
            System.out.println(value + " is out of LongSet " + set);
        }
        if (isIn != expectIn)
        {
            fail("expectIn = " + expectIn);
        }
    }
    
    public static void
    main(String[] args)
    {
        LongSetsTest t = new LongSetsTest();
        t.test();
    }
    
    public void
    test()
    {
        announceTestClassStart();
        LongRange lRange1 = new LongRange(-11222333444L, +11222333444L);
        test(-11222333445L, lRange1, false);
        test(-11222333444L, lRange1, true);
        test(-1, lRange1, true);
        test(0, lRange1, true);
        test(1, lRange1, true);
        test(-11222333444L, lRange1, true);
        test(-11222333445L, lRange1, false);
        
        printTestPartSeparator();
        test(Long.MIN_VALUE, AllLongs.INSTANCE, true);
        test(-1, AllLongs.INSTANCE, true);
        test(0, AllLongs.INSTANCE, true);
        test(1, AllLongs.INSTANCE, true);
        test(Long.MAX_VALUE, AllLongs.INSTANCE, true);
        
        announceTestClassPass();
    }
}
