/*
 * Copyright Rasmus Torkel 2013
 * Author    Rasmus Torkel 2013
 * 
 * You may only use this software subject to the terms and conditions which either you or your
 * organisation would have downloaded with this software and which should have been placed
 * somewhere accessible to you. These conditions are likely to
 * -- allow you or your organisation to determine whether you or your organisation
 *    may use this software for free or not and if not how to pay and how much;
 * -- prohibit or restrict republishing of this software and transmission to other organisations,
 *    even related companies within the same group;
 * -- prohibit the renaming of this class and the containing package.
 *    
 * Neither you nor your organisation may modify this header. However, you or your organisation
 * may modify anything below this header. If so, you or your organisation must place a comment
 * to that effect immediately below this header.
 */
package rasmus_torkel.test.text.write;

import rasmus_torkel.text.write.LineEndOption;

public class LineEndTest
{
    public static void
    test()
    {
        LineEndOption[] options = LineEndOption.values();
        for (LineEndOption option : options)
        {
            System.out.println();
            System.out.println("toString(): " + option.toString());
            System.out.println("label: " + option._label);
            int sLength = option._lineEndStr.length();
            System.out.print("lineEndStr:");
            for (int chIndex = 0; chIndex < sLength; chIndex++)
            {
                char ch = option._lineEndStr.charAt(chIndex);
                int chi = (int)ch;
                System.out.print(" " + Integer.toHexString(chi));
            }
            System.out.println();
            System.out.println("fullDescription: " + option._fullDescription);
        }
    }
    
    public static void
    setProperty(String lineEnd)
    {
        System.setProperty("line.separator", lineEnd);
    }
    
    public static void
    main(String[] args)
    {
        test();
        System.out.println();
        System.out.println("********************************************************");
        System.out.println(
                "We are changing the line end property but it should be too late to have any effect");
        setProperty("xx\n");
        test();
    }
}
