package rasmus_torkel.test.xml_basic.oo;

import rasmus_torkel.misc.ArrayMaker;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlSinkWritable;

public class O implements XmlSinkWritable
{
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("o", new XmlNameSpace("ns", "http://xx"));
    public static final MainXmlObjectFactory<O> FROM_XML_FACTORY = new MainXmlObjectFactory<O>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public O
        extractFromNode(TagNode node)
        {
            return new O(node);
        }
    };
    public static final ArrayMaker<O> ARRAY_MAKER = new ArrayMaker<O>()
    {
        @Override
        public O[]
        newArray(int size)
        {
            return new O[size];
        }
    }; 
    
    public final int _oId;
    
    public
    O(TagNode node)
    {
        _oId = node.nextIntFieldE("oId");
    }
    
    public
    O(int aId)
    {
        _oId = aId;
    }
    
    @Override
    public String
    toString()
    {
        return String.valueOf(_oId);
    }
    
    @Override
    public boolean
    equals(Object other)
    {
        if (other == null)
        {
            return false;
        }
        if (!(other instanceof O))
        {
            return false;
        }
        O otherO = (O)other;
        return _oId == otherO._oId;
    }

    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        xmlSink.sinkSimpleNode("oId", _oId);
    }
}
