package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.misc.ArrayMaker;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlSinkWritable;

public abstract class A implements XmlSinkWritable
{
    public static final MainXmlObjectFactory<A> FROM_XML_FACTORY = new MainXmlObjectFactory<A>((TagNodeId)null)
    {
        @Override
        public A
        extractFromNode(TagNode node)
        {
            throw makeExtractAbstractException();
        }
    };
    
    public static final ArrayMaker<A> ARRAY_MAKER = new ArrayMaker<A>()
    {
        @Override
        public A[]
        newArray(int size)
        {
            return new A[size];
        }
    };
    
    public final int _aId;
    
    public
    A(TagNode node)
    {
        _aId = node.nextIntFieldE("aId");
    }
    
    public
    A(int aId)
    {
        _aId = aId;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        xmlSink.sinkSimpleNode("aId", _aId);
    }
}
