package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class AaExtra extends A
{
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("aa");
    public static final MainXmlObjectFactory<Aa> FROM_XML_FACTORY = new MainXmlObjectFactory<Aa>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public Aa
        extractFromNode(TagNode node)
        {
            return new Aa(node);
        }
    };
    
    public final int _aaId;
    
    public
    AaExtra(TagNode node)
    {
        super(node);
        _aaId = node.nextIntFieldE("aaId");
    }

    public
    AaExtra(int aId,
            int aaId)
    {
        super(aId);
        _aaId = aaId;
    }

    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        super.mostToXml(xmlSink, relativeName, nameSpace);
        xmlSink.sinkSimpleNode("aaId", _aaId);
    }
}
