package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class Aaa extends Aa
{
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("aaa");
    public static final MainXmlObjectFactory<Aaa> FROM_XML_FACTORY = new MainXmlObjectFactory<Aaa>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public Aaa
        extractFromNode(TagNode node)
        {
            return new Aaa(node);
        }
    };
    
    public final int _aaaId;
    
    public
    Aaa(TagNode node)
    {
        super(node);
        _aaaId = node.nextIntFieldE("aaaId");
    }

    public
    Aaa(int aId,
        int aaId,
        int aaaId)
    {
        super(aId, aaId);
        _aaaId = aaaId;
    }

    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        super.mostToXml(xmlSink, relativeName, nameSpace);
        xmlSink.sinkSimpleNode("aaaId", _aaaId);
    }
}
