package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class Ab extends A
{
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("ab");
    public static final MainXmlObjectFactory<Ab> FROM_XML_FACTORY = new MainXmlObjectFactory<Ab>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public Ab
        extractFromNode(TagNode node)
        {
            return new Ab(node);
        }
    };
    
    public final int _abId;
    
    public
    Ab(TagNode node)
    {
        super(node);
        _abId = node.nextIntFieldE("abId");
    }

    public
    Ab(int aId,
       int abId)
    {
        super(aId);
        _abId = abId;
    }

    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        super.mostToXml(xmlSink, relativeName, nameSpace);
        xmlSink.sinkSimpleNode("abId", _abId);
    }
}
