package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class Ac extends A
{
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("ac");
    public static final MainXmlObjectFactory<Ac> FROM_XML_FACTORY = new MainXmlObjectFactory<Ac>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public Ac
        extractFromNode(TagNode node)
        {
            return new Ac(node);
        }
    };
    
    public final int _acId;
    
    public
    Ac(TagNode node)
    {
        super(node);
        _acId = node.nextIntFieldE("acId");
    }

    public
    Ac(int aId,
       int acId)
    {
        super(aId);
        _acId = acId;
    }

    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        super.mostToXml(xmlSink, relativeName, nameSpace);
        xmlSink.sinkSimpleNode("acId", _acId);
    }
}
