package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.misc.ArrayMaker;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlSinkWritable;

public class B implements XmlSinkWritable
{
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("b");
    public static final MainXmlObjectFactory<B> FROM_XML_FACTORY = new MainXmlObjectFactory<B>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public B
        extractFromNode(TagNode node)
        {
            return new B(node);
        }
    };
    public static final ArrayMaker<B> ARRAY_MAKER = new ArrayMaker<B>()
    {
        @Override
        public B[]
        newArray(int size)
        {
            return new B[size];
        }
    }; 
    
    public final int _bId;
    
    public
    B(TagNode node)
    {
        _bId = node.nextIntFieldE("bId");
    }
    
    public
    B(int aId)
    {
        _bId = aId;
    }
    
    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        xmlSink.sinkSimpleNode("bId", _bId);
    }
}
