package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.test_framework.UnitTestError;
import rasmus_torkel.text.read.exception.SurplusNodeException;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.XmlObjectFactory;
import rasmus_torkel.xml_basic.write.XmlSink;

public class DisableInheritanceTest extends UnitTest
{
    public static void
    main(String[] args)
    {
        announceTestClassStart(DisableInheritanceTest.class);
        XmlObjectFactory<Aa> exactAaFactory = new XmlObjectFactory<Aa>(Aa.class)
        {
            @Override
            public Aa
            extractFromNode(TagNode node)
            {
                return new Aa(node);
            }
        };
        
        Aa aa = new Aa(1001, 11001);
        Aaa aaa = new Aaa(1002, 11002, 111002);
        String aaXmlString = XmlSink.objectToString(aa);
        String aaaXmlString = XmlSink.objectToString(aaa);
        Aa aa2 = exactAaFactory.stringToObject(aaXmlString, "demo");
        System.out.println("aa2._aaId" + aa2._aaId);
        printEndTest();
        try
        {
            Aa aaUnexpected = exactAaFactory.stringToObject(aaaXmlString, "demo");
            System.out.println(
                    "Unexpectedly got Aa object back, _aaId = " + aaUnexpected._aaId +
                    ", class = " + aaUnexpected.getClass().getName());
            throw new UnitTestError();
        }
        catch (SurplusNodeException e)
        {
            System.out.println("Caught exception as expected: " + e);
        }
        printEndTest();
        announceTestClassPass(DisableInheritanceTest.class);
    }
}
