package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;

public class HierarchyReporter extends UnitTest
{
    public static void
    main(String[] args)
    {
        printAReport();
        MainXmlObjectFactory.forceLoad(Aaa.class);
        System.out.println("class Aaa should be loaded");
        printTestPartSeparator();
        printAReport();
        Class<?>[] classes = {Aaa.class, Ab.class, Ac.class, B.class, String.class};
        printReport(classes);
        printAReport();
        printReport(new Class<?>[]{A.class, X.class, Object.class, String.class, HierarchyReporter.class});
    }
    
    private static void
    printReport(Class<?>[] classes)
    {
        System.out.println("Class array report");
        for (Class<?> clas : classes)
        {
            System.out.println(clas);
        }
        printTestPartSeparator();
        String report = MainXmlObjectFactory.makeInheritanceReport(classes);
        System.out.print(report);
        printEndTest();
        System.out.println();
    }
    
    private static void
    printAReport()
    {
        System.out.println("Class branch report for A");
        printTestPartSeparator();
        String report = A.FROM_XML_FACTORY.makeInheritanceBranchReport();
        System.out.print(report);
        printEndTest();
        System.out.println();
    }
}
