package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object.EmployeeDemo;
import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.test_framework.UnitTestError;
import rasmus_torkel.text.read.exception.WrongNodeException;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.MiscXmlFunctions;
import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlSinkWritable;

public class TagIdInheritanceTest extends UnitTest
{
    public static void
    main(String[] args)
    {
        announceTestClassStart(TagIdInheritanceTest.class);
        A[] as = makeSample();
        System.out.println("A instances to XML conversion");
        System.out.println("");
        String xmlString = XmlSink.arrayToString("as", as);
        System.out.println(xmlString);
        printTestPartSeparator();
        MiscXmlFunctions.showXmlForHtml(xmlString);
        System.out.println("XML to A instances conversion");
        A[] as2 = A.FROM_XML_FACTORY.stringToArray(xmlString, "demo", A.ARRAY_MAKER, "as");
        String xmlString2 = XmlSink.arrayToString("as", as2);
        System.out.println(xmlString2);
        boolean equals = xmlString2.equals(xmlString);
        System.out.println("equals: " + equals);
        if (!equals)
        {
            throw new UnitTestError(EmployeeDemo.class);
        }
        printTestPartSeparator();
        String xmlBad = XmlSink.arrayToString("as", new XmlSinkWritable[]{new B(2)});
        try
        {
            A.FROM_XML_FACTORY.stringToArray(xmlBad, "demo", A.ARRAY_MAKER, "as");
            throw new UnitTestError(TagIdInheritanceTest.class);
        }
        catch (WrongNodeException e)
        {
            System.out.println("Got exception as expected: " + e);
            //e.printStackTrace(System.out);
            printEndTest();
        }
        MainXmlObjectFactory.forceLoad(AaExtra.class);
        System.out.println("Loaded AaExtra with same natural tag id as Aa");
        try
        {
            A.FROM_XML_FACTORY.stringToArray(xmlString2, "demo", A.ARRAY_MAKER, "as");;
            throw new UnitTestError(TagIdInheritanceTest.class);
        }
        catch (Exception e)
        {
            System.out.println("Got exception as expected: " + e);
            printEndTest();
        }
        announceTestClassPass(TagIdInheritanceTest.class);
    }
    
    public static A[]
    makeSample()
    {
        A[] as = new A[]{new Aa(1001, 11001), new Ab(1002, 12002), new Aaa(1003, 11003, 11103), new Ac(1004, 13004)};
        return as;
    }
}
