package rasmus_torkel.test.xml_basic.oo.inheritance;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.XmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlSinkWritable;

public class X implements XmlSinkWritable
{
    public static XmlObjectFactory<X> FROM_XML_FACTORY = new XmlObjectFactory<X>(X.class)
    {
        @Override
        public X extractFromNode(TagNode node)
        {
            return new X(node);
        }
    };
    
    public final String    _role;
    public final int       _xId;
    public final TagNodeId _tagNodeId;
    
    public
    X(TagNode node)
    {
        _role = node._id._relativeName;
        _xId = node.nextIntFieldE("xId");
        _tagNodeId = node._id;
    }
    
    public
    X(String role,
      int    xId)
    {
        _role = role;
        _xId = xId;
        _tagNodeId = new TagNodeId(_role);
    }

    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return _tagNodeId;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        xmlSink.sinkSimpleNode("xId", _xId);
    }
}
