package rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object;

import rasmus_torkel.test.xml_basic.oo.PersonName;
import rasmus_torkel.text.type.factory.date.Date2;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.types.date.YmdHyphenPaddedDateXmlFactory;
import rasmus_torkel.xml_basic.write.XmlSink;

public class Ceo extends Manager
{
    public final Date2 _ceoStartDate;
    
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("ceo");
    
    public static final MainXmlObjectFactory<Ceo> FROM_XML_FACTORY = new MainXmlObjectFactory<Ceo>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public Ceo extractFromNode(TagNode node)
        {
            return new Ceo(node);
        }
    };
    
    public
    Ceo(TagNode node)
    {
        super(node, false);
        _ceoStartDate = YmdHyphenPaddedDateXmlFactory.INSTANCE.nextFieldE(node, "ceoStartDate");
    }
    
    public
    Ceo(long       id,
        PersonName name,
        Date2      birthDate,
        Date2      joinDate,
        int        salary,
        Gender     gender,
        Date2      managementStartDate,
        Date2      ceoStartDate)
    {
        super(id, -1, name, birthDate, joinDate, salary, gender, managementStartDate);
        _ceoStartDate = ceoStartDate;
    }

    @Override
    public TagNodeId naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }

    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        super.mostToXml(xmlSink, relativeName, nameSpace);
        xmlSink.sinkSimpleNode("ceoStartDate", _ceoStartDate);
    }
}
