package rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object;

import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.test_framework.UnitTestError;
import rasmus_torkel.xml_basic.rw.MiscXmlFunctions;
import rasmus_torkel.xml_basic.write.XmlSink;

public class CompanyDemo extends UnitTest
{
    public static void
    main(String[] args)
    {
        announceTestClassStart(CompanyDemo.class);
        Company company = makeCompanySample();
        String xmlString = XmlSink.objectToString(company);
        System.out.println(xmlString);
        printTestPartSeparator();
        MiscXmlFunctions.showXmlForHtml(xmlString);
        printTestPartSeparator();
        System.out.println("Getting XML again to test for equality");
        Company company2 = Company.FROM_XML_FACTORY.stringToObject(xmlString, "demo");
        String xmlString2 = XmlSink.objectToString(company2);
        boolean equals = xmlString2.equals(xmlString);
        System.out.println("equals: " + equals);
        if (!equals)
        {
            throw new UnitTestError();
        }
        printEndTest();
        announceTestClassPass(CompanyDemo.class);
    }
    
    public static Company
    makeCompanySample()
    {
        Employee[] employees = EmployeeDemo.makeEmployeeSample();
        Company company = new Company("ABC Software", employees);
        return company;
    }
}
