package rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object;

import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.test_framework.UnitTestError;
import rasmus_torkel.xml_basic.read.exception.XmlTypedNodeException;

public class EmployeeFactoryErrors extends UnitTest
{
    public static void
    main(String[] args)
    {
        UnitTest.announceTestClassStart(EmployeeFactoryErrors.class);
        testError("<employees><employee classOfObject=\"rasmus_torkel.test.xml_basic.oo.PersonName\"><firstName>Sam</firstName><middleNames/><surname>Smith</surname></employee></employees>");
        testError("<employees><employee classOfObject=\"john_smith.employee.Employee\"></employee></employees>");
        testError("<employees><employee classOfObject=\"rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object.Gender\"></employee></employees>");
        testError("<employees><employee classOfObject=\"rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object.ClassWithWrongTypeFactory\"></employee></employees>");
        testError("<employees><employee classOfObject=\"rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object.ClassWithNonStaticFactory\"></employee></employees>");
        testError("<employees><employee classOfObject=\"rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object.ClassWithNullFactory\"></employee></employees>");
        testError("<employees><employee classOfObject=\"rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object.ClassWithPrivateFactory\"></employee></employees>");
        UnitTest.announceTestClassPass(EmployeeFactoryErrors.class);
    }
    
    public static void
    testError(String xml)
    {
        try
        {
            EmployeeDemo.xmlToEmployees(xml);
            System.out.println("xml to employee conversion unexpectedly succeeded");
            throw new UnitTestError(EmployeeFactoryErrors.class);
        }
        catch (XmlTypedNodeException e)
        {
            System.out.println("Got exception as expected: " + e);
        }
        catch (Exception e)
        {
            System.out.println("Got exception of unexpected type");
            e.printStackTrace(System.out);
            throw new UnitTestError(EmployeeFactoryErrors.class);
        }
    }
}
