package rasmus_torkel.test.xml_basic.oo.inheritance.class_of_object;

import rasmus_torkel.test.xml_basic.oo.PersonName;
import rasmus_torkel.text.type.factory.date.Date2;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.factory.MainXmlObjectFactory;
import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.types.date.YmdHyphenPaddedDateXmlFactory;
import rasmus_torkel.xml_basic.write.XmlSink;

public class Manager extends Employee
{
    public final Date2 _managementStartDate;
    
    public static final TagNodeId NATURAL_TAG_NODE_ID = new TagNodeId("manager");
    
    public static final MainXmlObjectFactory<Manager> FROM_XML_FACTORY = new MainXmlObjectFactory<Manager>(NATURAL_TAG_NODE_ID)
    {
        @Override
        public Manager extractFromNode(TagNode node)
        {
            return new Manager(node);
        }
    };
    
    public
    Manager(TagNode node)
    {
        this(node, true);
    }
    
    protected
    Manager(TagNode node,
            boolean isBossIdExpected)
    {
        super(node,
              isBossIdExpected);
        _managementStartDate = YmdHyphenPaddedDateXmlFactory.INSTANCE.nextFieldE(node, "managementStartDate");
    }
    
    public
    Manager(long       id,
            long       bossId,
            PersonName name,
            Date2      birthDate,
            Date2      joinDate,
            int        salary,
            Gender     gender,
            Date2      managementStartDate)
    {
        super(id, bossId, name, birthDate, joinDate, salary, gender);
        _managementStartDate = managementStartDate;
    }

    @Override
    public TagNodeId
    naturalTagNodeId()
    {
        return NATURAL_TAG_NODE_ID;
    }
    
    @Override
    public void
    mostToXml(XmlSink      xmlSink,
              String       relativeName,
              XmlNameSpace nameSpace)
    {
        super.mostToXml(xmlSink, relativeName, nameSpace);
        xmlSink.sinkSimpleNode("managementStartDate", _managementStartDate);
    }
}
