/*
 * Copyright Rasmus Torkel 2016
 * Author    Rasmus Torkel 2016
 * 
 * You may only use this software subject to the terms and conditions which either you or your
 * organisation would have downloaded with this software and which should have been placed
 * somewhere accessible to you. These conditions are likely to
 * -- allow you or your organisation to determine whether you or your organisation
 *    may use this software for free or not and if not how to pay and how much;
 * -- prohibit or restrict republishing of this software and transmission to other organisations,
 *    even related companies within the same group;
 * -- prohibit the renaming of this class and the containing package.
 *    
 * Neither you nor your organisation may modify this header. However, you or your organisation
 * may modify anything below this header. If so, you or your organisation must place a comment
 * to that effect immediately below this header.
 */
package rasmus_torkel.test.xml_basic.performance;

import java.io.File;

public abstract class BigWriteTest
{
    static int ITERATION_QTY = 11000;
    
    private   final long _time0;
    private         long _time1000;
    protected       int  _i;
    
    protected
    BigWriteTest()
    {
        _time0 = System.currentTimeMillis();
        System.out.println(getClass().getName() + " start: " + _time0);
    }
    
    public static File
    getFile(Class<?> clas)
    {
        return new File("./data/rasmus_torkel/test/xml_basic/performance/"+ clas.getSimpleName() + ".xml");
    }
    
    public void
    write()
    {
        try
        {
            File file = getFile(getClass());
            start(file);
            for (_i = 0; _i < ITERATION_QTY; _i++)
            {
                iteration();
                long time = System.currentTimeMillis();
                int qty = _i + 1;
                if (qty == 1 || qty == 10 || qty == 100 || qty % 1000 == 0)
                {
                    System.out.println("After " + (_i + 1) + ": " + (time - _time0));
                }
                if (qty == 1000)
                {
                    _time1000 = time;
                }
                if (qty == 11000)
                {
                    System.out.println((time - _time1000) + " for 10000");
                }
            }
            end();
            System.out.println(getClass().getName() + " finished: " + (System.currentTimeMillis() - _time0));
            System.out.println("-------------------------");
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
    
    protected abstract void
    start(File file) throws Exception;
    
    protected abstract void
    iteration() throws Exception;
    
    protected abstract void
    end() throws Exception;
}
