/*
 * Copyright Rasmus Torkel 2016
 * Author    Rasmus Torkel 2016
 * 
 * You may only use this software subject to the terms and conditions which either you or your
 * organisation would have downloaded with this software and which should have been placed
 * somewhere accessible to you. These conditions are likely to
 * -- allow you or your organisation to determine whether you or your organisation
 *    may use this software for free or not and if not how to pay and how much;
 * -- prohibit or restrict republishing of this software and transmission to other organisations,
 *    even related companies within the same group;
 * -- prohibit the renaming of this class and the containing package.
 *    
 * Neither you nor your organisation may modify this header. However, you or your organisation
 * may modify anything below this header. If so, you or your organisation must place a comment
 * to that effect immediately below this header.
 */
package rasmus_torkel.test.xml_basic.performance;

import java.io.File;
import java.io.FileWriter;

import rasmus_torkel.text.write.LineEndOption;

public class FileWriterBigXmlTest extends BigWriteTest
{
    private String _lineEnd = LineEndOption.SYSTEM_PROPERTY._lineEndStr;
    private FileWriter _writer;
    
    public static void
    main(String[] args)
    {
        new FileWriterBigXmlTest().write();
    }

    @Override
    protected void
    start(File file) throws Exception
    {
        _writer = new FileWriter(file);
        _writer.write("<root xmlns:xx=\"www.rasmus_torkel.com/perftest\">" + _lineEnd);
    }

    @Override
    protected void
    iteration() throws Exception
    {
        _writer.write("  <xx:element attrName=\"" + _i + "\">" + _lineEnd);
        _writer.write("    <field>" + _i + "</field>" + _lineEnd);
        _writer.write("  </xx:element>" + _lineEnd);
    }

    @Override
    protected void
    end() throws Exception
    {
        _writer.write("</root>");
        _writer.close();
    }
}
