/*
 * Copyright Rasmus Torkel 2016
 * Author    Rasmus Torkel 2016
 * 
 * You may only use this software subject to the terms and conditions which either you or your
 * organisation would have downloaded with this software and which should have been placed
 * somewhere accessible to you. These conditions are likely to
 * -- allow you or your organisation to determine whether you or your organisation
 *    may use this software for free or not and if not how to pay and how much;
 * -- prohibit or restrict republishing of this software and transmission to other organisations,
 *    even related companies within the same group;
 * -- prohibit the renaming of this class and the containing package.
 *    
 * Neither you nor your organisation may modify this header. However, you or your organisation
 * may modify anything below this header. If so, you or your organisation must place a comment
 * to that effect immediately below this header.
 */
package rasmus_torkel.test.xml_basic.performance;

import java.io.File;

import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class XmlSinkBigTest extends BigWriteTest
{
    public static final XmlNameSpace NAME_SPACE = new XmlNameSpace("xx", "www.rasmus_torkel.com/perftest");
    private XmlSink      _xmlSink;
    
    public static void
    main(String[] args)
    {
        new XmlSinkBigTest().write();
    }

    @Override
    protected void start(File file) throws Exception
    {
        //_nameSpace = new XmlNameSpace("xx", "www.rasmus_torkel.com/perftest");
        _xmlSink = new XmlSink(file);
        _xmlSink.startNode("root");
        _xmlSink.declareNameSpace(NAME_SPACE);
    }

    @Override
    protected void iteration() throws Exception
    {
        _xmlSink.startNode("element", NAME_SPACE);
        _xmlSink.sinkAttribute("attrName", _i);
        _xmlSink.sinkSimpleNode("field", _i);
        _xmlSink.closeNode();
    }

    @Override
    protected void end() throws Exception
    {
        _xmlSink.closeNode();
    }
}
