package rasmus_torkel.test.xml_basic.read.impl;

import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;
import rasmus_torkel.xml_basic.write.XmlSink;

public class XmlEmptyTagTest extends UnitTest
{
    public static final String selfClosing = "<root><x/></root>";
    public static final String startAndEnd = "<root><x></x></root>";
    
    public static void
    main(String[] args)
    {
        readX(startAndEnd);
        readX(selfClosing);
        writeX("");
        writeX(null);
    }
    
    public static String
    readX(String xml)
    {
        System.out.println("readX");
        printTestPartSeparator();
        System.out.println(xml);
        printTestPartSeparator();
        TagNode rootNode = XmlReader.xmlStringToRoot(xml, "unit test", XmlReadOptions.DEFAULT);
        String x = rootNode.nextTextFieldN("x");
        rootNode.readRest();
        System.out.println("x = " + x);
        printEndTest();
        return x;
    }
    
    public static String
    writeX(String x)
    {
        System.out.println("writeX");
        printTestPartSeparator();
        System.out.println("x = " + x);
        printTestPartSeparator();
        XmlSink sink = new XmlSink();
        sink.startNode("root");
        sink.sinkSimpleNode("x", x);
        sink.closeNode();
        String xml = sink.toString();
        System.out.println(xml);
        printEndTest();
        return xml;
    }
}
