package rasmus_torkel.test.xml_basic.read.impl;

import rasmus_torkel.set.chars.DefinedCharSets;
import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.test_framework.UnitTestError;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;
import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlWriteOptions;

public class XmlReaderSuiteAllChars extends UnitTest
{
    public static void
    main(String[] args)
    {
        announceTestClassStart(XmlReaderSuiteAllChars.class);
        XmlWriteOptions writeOptions = XmlWriteOptions.DEFAULT.diffAllCharSet(DefinedCharSets.BITS_16);
        XmlSink sink = new XmlSink(writeOptions);
        sink.startNode("allChars");
        for (int chi = 0; chi <= 0xffff; chi++)
        {
            char ch = (char)chi;
            sink.sinkSimpleNode("ch", ch);
        }
        sink.closeNode();
        String xml = sink.toString();
        System.out.println(xml);
        printTestPartSeparator();
        XmlReadOptions readOptions = XmlReadOptions.DEFAULT.diffValueCharSet(DefinedCharSets.BITS_16);
        TagNode rootNode = XmlReader.xmlStringToRoot(xml, "XmlReaderSuiteAllChars", readOptions, "allChars");
        long total = 0;
        boolean finished = false;
        while (!finished)
        {
            String s = rootNode.nextTextFieldN("ch");
            if (s == null)
            {
                finished = true;
            }
            else if (s.length() != 1)
            {
                System.out.println("Retrieved ch element of length " + s.length());
            }
            else
            {
                char ch = s.charAt(0);
                total += (long)ch;
            }
        }
        System.out.println("total =  " + total);
        long expectedTotal = (0xffffL * 0xffffL + 0xffffL) / 2;
        System.out.println("Expected " + expectedTotal);
        if (total != expectedTotal)
        {
            throw new UnitTestError();
        }
        announceTestClassPass(XmlReaderSuiteAllChars.class);
    }
}
