package rasmus_torkel.test.xml_basic.read.impl;

import rasmus_torkel.test_framework.UnitTest;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;

public class XmlReaderSuiteNameSpaces extends UnitTest
{
    public static void
    main(String[] args)
    {
        announceTestClassStart(XmlReaderSuiteNameSpaces.class);
        testOk("<a xmlns:n=\"NS1\"><b><n:c>hello</n:c></b></a>");
        testOk("<a><b xmlns:n=\"NS1\"><n:c>hello</n:c></b></a>");
        testOk("<a><b><n:c xmlns:n=\"NS1\">hello</n:c></b></a>");
        testOk("<a xmlns:n=\"NS1\" xmlns:x=\"NS1\"><b><n:c>hello</n:c></b></a>");
        testOk("<a xmlns:x=\"NS1\" xmlns:n=\"NS1\"><b><n:c>hello</n:c></b></a>");
        testOk("<a xmlns:n=\"NS1\"><b><n:c xmlns:x=\"NS1\">hello</n:c></b></a>");
        testOk("<a xmlns:x=\"NS1\"><b><n:c xmlns:n=\"NS1\">hello</n:c></b></a>");
        testOk("<a xmlns:n=\"NS1\"><b xmlns:n=\"\"><n:c xmlns:n=\"NS1\">hello</n:c></b></a>");
        testOk("<a xmlns:n=\"NS2\"><b xmlns:n=\"\"><n:c xmlns:n=\"NS1\">hello</n:c></b></a>");
        announceTestClassPass(XmlReaderSuiteNameSpaces.class);
    }
    
    private static final XmlNameSpace nameSpace = new XmlNameSpace("n", "NS1");
    
    public static void
    testOk(String xml)
    {
        System.out.println(xml);
        printRuler(xml);
        printTestPartSeparator();
        TagNode rootNode = XmlReader.xmlStringToRoot(xml, "unit test", XmlReadOptions.DEFAULT, "a");
        TagNode middleNode = rootNode.nextChildE("b");
        String innerText = middleNode.nextConstFieldE("c", nameSpace, "hello");
        System.out.println(innerText);
        printEndTest();
    }
}
