package rasmus_torkel.test.xml_basic.simple;

import java.io.File;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;
import rasmus_torkel.xml_basic.rw.MiscXmlFunctions;
import rasmus_torkel.xml_basic.write.XmlSink;

public class SimpleXmlAttrDemo
{
    public static void
    main(String[] args)
    {
        String xmlString = makeXml();
        readXml(xmlString);
    }
    
    public static String
    makeXml()
    {
        String name = "Rasmus Torkel";
        int numberOfFingers = 10;
        File file = new File("./data/xx.txt");
        SimpleXmlDemo.printSampleData(name, numberOfFingers, file);
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("sample");
        xmlSink.sinkAttribute("name", name);
        xmlSink.sinkAttribute("numberOfFingers", numberOfFingers);
        xmlSink.sinkAttribute("file", file);
        xmlSink.closeTagAndNode();
        String xmlString = xmlSink.toString();
        System.out.println(xmlString);
        MiscXmlFunctions.showXmlForHtml(xmlString);
        return xmlString;
    }
    
    public static void
    readXml(String xmlString)
    {
        TagNode sampleNode = XmlReader.xmlStringToRoot(xmlString, "demo", XmlReadOptions.DEFAULT, "sample");
        String name = sampleNode.attributeValueE("name");
        int numberOfFingers = sampleNode.attributeIntD("numberOfFingers", 10);
        File file = (File)sampleNode.attributeStringMappedN("file", File.class);
        sampleNode.verifyNoMoreChildren();
        SimpleXmlDemo.printSampleData(name, numberOfFingers, file);
    }
}
