package rasmus_torkel.test.xml_basic.simple;

import java.io.File;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;
import rasmus_torkel.xml_basic.rw.MiscXmlFunctions;
import rasmus_torkel.xml_basic.rw.XmlAttribute;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class SimpleXmlAttrNsDemo
{
    public static void
    main(String[] args)
    {
        String xmlString = makeXml();
        readXml(xmlString);
    }
    
    public static String
    makeXml()
    {
        String name = "Rasmus Torkel";
        int numberOfFingers = 10;
        File file = new File("./data/xx.txt");
        SimpleXmlDemo.printSampleData(name, numberOfFingers, file);
        XmlNameSpace ns = new XmlNameSpace("x", "http://rasmustorkel.com/ns1/");
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("sample");
        xmlSink.sinkAttribute(new XmlAttribute("name", ns, name));
        xmlSink.sinkAttribute(new XmlAttribute("numberOfFingers", ns, String.valueOf(numberOfFingers)));
        xmlSink.sinkAttribute(new XmlAttribute("file", ns, String.valueOf(file)));
        xmlSink.closeTagAndNode();
        String xmlString = xmlSink.toString();
        System.out.println(xmlString);
        MiscXmlFunctions.showXmlForHtml(xmlString);
        return xmlString;
    }
    
    public static void
    readXml(String xmlString)
    {
        XmlNameSpace ns = new XmlNameSpace("x", "http://rasmustorkel.com/ns1/");
        TagNode sampleNode = XmlReader.xmlStringToRoot(xmlString, "demo", XmlReadOptions.DEFAULT, "sample");
        String name = sampleNode.attributeValueN("name", ns);
        String numberOfFingersStr = sampleNode.attributeValueN("numberOfFingers", ns);
        String fileStr = sampleNode.attributeValueN("file", ns);
        sampleNode.verifyNoMoreChildren();
        SimpleXmlDemo.printSampleData(name, Integer.parseInt(numberOfFingersStr), new File(fileStr));
    }
}
