/*
 * Copyright Rasmus Torkel 2015
 * Author    Rasmus Torkel 2015
 * 
 * You may only use this software subject to the terms and conditions which either you or your
 * organisation would have downloaded with this software and which should have been placed
 * somewhere accessible to you. These conditions are likely to
 * -- allow you or your organisation to determine whether you or your organisation
 *    may use this software for free or not and if not how to pay and how much;
 * -- prohibit or restrict republishing of this software and transmission to other organisations,
 *    even related companies within the same group;
 * -- prohibit the renaming of this class and the containing package.
 *    
 * Neither you nor your organisation may modify this header. However, you or your organisation
 * may modify anything below this header. If so, you or your organisation must place a comment
 * to that effect immediately below this header.
 */
package rasmus_torkel.test.xml_basic.simple;

import java.io.File;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;

public class SimpleXmlFileReadDemo
{
    public static void
    main(String[] args)
    {
        File xmlFile = new File("./data/rasmus_torkel/demo/xml_basic/fordocs/simple.xml");
        TagNode sampleNode = XmlReader.xmlFileToRoot(xmlFile, XmlReadOptions.DEFAULT, "sample");
        String name = sampleNode.nextTextFieldE("name");
        int numberOfFingers = sampleNode.nextIntFieldD("numberOfFingers", 10);
        File file = (File)sampleNode.nextStringMappedFieldN("file", File.class);
        sampleNode.verifyNoMoreChildren();
        
        System.out.println("name: " + name);
        System.out.println("numberOfFingers: " + numberOfFingers);
        System.out.println("file: " + file);
    }
}
