package rasmus_torkel.test.xml_basic.simple;

import java.io.File;

import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;
import rasmus_torkel.xml_basic.rw.MiscXmlFunctions;
import rasmus_torkel.xml_basic.write.XmlSink;

public class SimpleXmlNestDemo
{
    public static void
    main(String[] args)
    {
        String xmlString = makeXml();
        readXml(xmlString);
    }
    
    public static String
    makeXml()
    {
        String firstName = "Rasmus";
        String surname = "Torkel";
        int numberOfFingers = 10;
        File file = new File("./data/xx.txt");
        printSampleData(firstName, surname, numberOfFingers, file);
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("sample");
        xmlSink.startNode("name");
        xmlSink.sinkSimpleNode("firstName", firstName);
        xmlSink.sinkSimpleNode("surname", surname);
        xmlSink.closeNode();
        xmlSink.sinkSimpleNode("numberOfFingers", numberOfFingers);
        xmlSink.sinkSimpleNode("file", file);
        xmlSink.closeNode();
        String xmlString = xmlSink.toString();
        System.out.println(xmlString);
        MiscXmlFunctions.showXmlForHtml(xmlString);
        return xmlString;
    }
    
    public static void
    readXml(String xmlString)
    {
        TagNode sampleNode = XmlReader.xmlStringToRoot(xmlString, "demo", XmlReadOptions.DEFAULT, "sample");
        TagNode nameNode = sampleNode.nextChildE("name");
        String firstName = nameNode.nextTextFieldE("firstName");
        String surname = nameNode.nextTextFieldE("surname");
        nameNode.verifyNoMoreChildren();
        int numberOfFingers = sampleNode.nextIntFieldD("numberOfFingers", 10);
        File file = (File)sampleNode.nextStringMappedFieldN("file", File.class);
        sampleNode.verifyNoMoreChildren();
        printSampleData(firstName, surname, numberOfFingers, file);
    }
    
    public static void
    printSampleData(String firstName,
                    String surname,
                    int    numberOfFingers,
                    File   file)
    {
        System.out.println("firstName = " + firstName);
        System.out.println("surname = " + surname);
        System.out.println("numberOfFingers = " + numberOfFingers);
        System.out.println("file = " + file);
        System.out.println();
    }
}
