package rasmus_torkel.test.xml_basic.write;

import rasmus_torkel.xml_basic.rw.XmlAttribute;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class XmlWriteNameSpaceTest extends XmlWriteTest
{
    private static final String       NS_NAME_1 = "rasmustorkel.com/namespace_1";
    private static final XmlNameSpace NS_1A = new XmlNameSpace("a", NS_NAME_1);
    private static final XmlNameSpace NS_1B = new XmlNameSpace("b", NS_NAME_1);
    
    public static void
    main(String[] args)
    {
        test1();
        test1b();
        test2();
        test2b();
        test3();
        test3b();
    }
    
    public static void
    test1()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test1");
        xmlSink.declareNameSpace(NS_1A);
        xmlSink.sinkSimpleNode("simpleNode", NS_1B, "Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test1b()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test1b");
        xmlSink.sinkSimpleNode("simpleNode", NS_1B, "Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test2()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test2", NS_1A);
        xmlSink.declareNameSpace(NS_1B);
        xmlSink.sinkText("Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test2b()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test2b", NS_1A);
        xmlSink.sinkText("Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test3()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test3");
        xmlSink.declareNameSpace(NS_1A);
        XmlAttribute attr = new XmlAttribute("attr", NS_1B, "value");
        xmlSink.sinkAttribute(attr);
        xmlSink.sinkSimpleNode("simpleNode", "Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test3b()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test3b");
        XmlAttribute attr = new XmlAttribute("attr", NS_1B, "value");
        xmlSink.sinkAttribute(attr);
        xmlSink.sinkSimpleNode("simpleNode", "Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
}
