package rasmus_torkel.test.xml_basic.write;

import rasmus_torkel.xml_basic.rw.XmlAttribute;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class XmlWriteTest2 extends XmlWriteTest
{
    private static final String       NS_NAME_1 = "rtorkel.com/namespace_1";
    private static final String       NS_NAME_2 = "rtorkel.com/namespace_2";
    private static final XmlNameSpace NS_1A = new XmlNameSpace("_1a", NS_NAME_1);
    private static final XmlNameSpace NS_1B = new XmlNameSpace("_1b", NS_NAME_1);
    private static final XmlNameSpace NS_1C = new XmlNameSpace("_1c", NS_NAME_1);
    private static final XmlNameSpace NS_1D = new XmlNameSpace("_1d", NS_NAME_1);
    private static final XmlNameSpace NS_2 = new XmlNameSpace("_2", NS_NAME_2);
    
    public static void
    main(String[] args)
    {
        test1();
        test2();
        test3();
        test4();
        test5();
        testAttrSameRelDiffNs();
    }
    
    public static void
    test1()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test1");
        //xmlSink.sinkAttribute("xmlns:" + NS_1A._prefix, NS_NAME_1);
        xmlSink.sinkSimpleNode("simpleNode", NS_1B, "Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test2()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test2", NS_1A);
        //xmlSink.sinkAttribute("xmlns:" + NS_1A._prefix, NS_NAME_1);
        xmlSink.sinkText("Hello World!");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test3()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test3");
        sinkSimpleNsNode(xmlSink, NS_1A);
        sinkSimpleNsNode(xmlSink, NS_1B);
        sinkSimpleNsNode(xmlSink, NS_2);
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test4()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test4", NS_1A);
        xmlSink.startNode("sub1", NS_1B);
        sinkSimpleNsNode(xmlSink, NS_1C);
        xmlSink.closeNode();
        sinkSimpleNsNode(xmlSink, NS_1D);
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    test5()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("test5");
        xmlSink.declareNameSpace(NS_1A);
        xmlSink.sinkText("Hello");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    public static void
    testAttrSameRelDiffNs()
    {
        XmlSink xmlSink = new XmlSink();
        xmlSink.startNode("testAttrSameRelDiffNs");
        xmlSink.declareNameSpace(NS_1A);
        xmlSink.declareNameSpace(NS_2);
        xmlSink.sinkAttribute("a", "1");
        xmlSink.sinkAttribute(new XmlAttribute("a", NS_1A, "2"));
        xmlSink.sinkAttribute(new XmlAttribute("a", NS_2, "3"));
        xmlSink.sinkAttribute(new XmlAttribute("b", NS_2, "4"));
        xmlSink.sinkAttribute(new XmlAttribute("b", NS_1A, "5"));
        xmlSink.sinkAttribute("b", "6");
        xmlSink.closeNode();
        checkXmlSyntax(xmlSink);
    }
    
    private static void
    sinkSimpleNsNode(XmlSink      xmlSink,
                     XmlNameSpace nameSpace)
    {
        xmlSink.sinkSimpleNode(nameSpace._prefix, nameSpace, nameSpace._name);
    }
}
