package rasmus_torkel.test.xml_basic.write;

import rasmus_torkel.xml_basic.rw.TagNodeId;
import rasmus_torkel.xml_basic.rw.XmlNameSpace;
import rasmus_torkel.xml_basic.write.XmlSink;

public class XmlWriteTestTypes extends XmlWriteTest
{
    public static final XmlNameSpace NS1 = new XmlNameSpace("x", "http:/rasmustorkel.com");
    
    public static void
    main(String[] args)
    {
        String nullString = null;
        Object nullObject = null;
        XmlSink sink = new XmlSink();
        sink.startNode("root");
        sink.declareNameSpace(NS1);
        sink.startNode("simple");
        sink.sinkSimpleNode("string", "s");
        sink.sinkSimpleNode("object", NS1);
        sink.sinkSimpleNode("int", 91420);
        sink.sinkSimpleNode("long", 121514070012151407L);
        sink.sinkSimpleNode("float", 1F/7F);
        sink.sinkSimpleNode("double", Math.PI);
        sink.sinkSimpleNode("boolean", true);
        sink.sinkSimpleNode("nullString", nullString);
        sink.sinkSimpleNode("nullObject", nullObject);
        sink.closeNode();
        sink.startNode("rel_ns");
        sink.sinkSimpleNode("string", NS1, "s");
        sink.sinkSimpleNode("object", NS1, NS1);
        sink.sinkSimpleNode("int", NS1, 91420);
        sink.sinkSimpleNode("long", NS1, 121514070012151407L);
        sink.sinkSimpleNode("float", NS1, 1F/7F);
        sink.sinkSimpleNode("double", NS1, Math.PI);
        sink.sinkSimpleNode("boolean", NS1, true);
        sink.sinkSimpleNode("nullString", NS1, nullString);
        sink.sinkSimpleNode("nullObject", NS1, nullObject);
        sink.closeNode();
        sink.startNode("ids");
        sink.sinkSimpleNode(new TagNodeId("string", NS1), "s");
        sink.sinkSimpleNode(new TagNodeId("object", NS1), NS1);
        sink.sinkSimpleNode(new TagNodeId("int", NS1), 91420);
        sink.sinkSimpleNode(new TagNodeId("long", NS1), 121514070012151407L);
        sink.sinkSimpleNode(new TagNodeId("float", NS1), 1F/7F);
        sink.sinkSimpleNode(new TagNodeId("double", NS1), Math.PI);
        sink.sinkSimpleNode(new TagNodeId("boolean", NS1), true);
        sink.sinkSimpleNode(new TagNodeId("nullString", NS1), nullString);
        sink.sinkSimpleNode(new TagNodeId("nullObject", NS1), nullObject);
        sink.closeNode();
        sink.startNode("attributes");
        sink.sinkAttribute("string", "s");
        sink.sinkAttribute("object", NS1);
        sink.sinkAttribute("int", 91420);
        sink.sinkAttribute("long", 121514070012151407L);
        sink.sinkAttribute("float", 1F/7F);
        sink.sinkAttribute("double", Math.PI);
        sink.sinkAttribute("boolean", true);
        sink.sinkAttribute("nullString", nullString);
        sink.sinkAttribute("nullObject", nullObject);
        sink.closeTagAndNode();
        sink.closeNode();
        checkXmlSyntax(sink);
    }
}
