package rasmus_torkel.test.xml_basic.write;

import rasmus_torkel.test_framework.UnitTestError;
import rasmus_torkel.xml_basic.read.TagNode;
import rasmus_torkel.xml_basic.read.XmlReadOptions;
import rasmus_torkel.xml_basic.read.impl.XmlReader;
import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlWriteOptions;

public class XmlWriteTestUtil
{
    public static void
    printAndCheckXmlSyntax(XmlSink xmlSink)
    {
        String xml = xmlSink.toString();
        System.out.println(xml);
        TagNode node = XmlReader.xmlStringToRoot(xml, "Unit test", XmlReadOptions.DEFAULT);
        try
        {
            node.readRest();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new UnitTestError(XmlWriteTest2.class);
        }
    }
    
    public static void
    checkXmlSyntax(XmlWriteOptions options,
                   boolean         wantPrint)
    {
        String xml = options.toXml();
        checkXmlSyntax(xml, wantPrint);
    }
    
    public static void
    checkXmlSyntax(XmlSink xmlSink,
                   boolean wantPrint)
    {
        String xml = xmlSink.toString();
        checkXmlSyntax(xml, wantPrint);
    }
    
    public static void
    checkXmlSyntax(String  xml,
                   boolean wantPrint)
    {
        if (wantPrint)
        {
            System.out.println(xml);
        }
        TagNode node = XmlReader.xmlStringToRoot(xml, "Unit test", XmlReadOptions.DEFAULT);
        try
        {
            node.readRest();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new UnitTestError(XmlWriteTest2.class);
        }
    }
}
