package rasmus_torkel.test.xml_basic.write;

import rasmus_torkel.xml_basic.write.XmlSink;
import rasmus_torkel.xml_basic.write.XmlWriteOptions;

public class XmlWriteValueEncodeTest
{
    public static void
    main(String[] main)
    {
        XmlWriteOptions writeOptions = XmlWriteOptions.DEFAULT;
        String s = test(writeOptions);
        System.out.println(s);
    }
    public static String
    test(XmlWriteOptions writeOptions)
    {
        XmlSink xmlSink = new XmlSink(writeOptions);
        xmlSink.startNode("all_valid_chars");
        int blockSize = 32;
        for (int blockStart = 0; blockStart < (int)0x10000; blockStart += blockSize)
        {
            int blockEnd = blockStart + blockSize - 1;
            StringBuilder buf = new StringBuilder();
            for (int chi = blockStart; chi <= blockEnd; chi++)
            {
                char ch = (char)chi;
                if (writeOptions._encodeOptions._allChars.isIn(ch))
                {
                    buf.append(ch);
                }
            }
            String nodeName = "block_" + Integer.toString(blockStart, 16) + "_" + Integer.toString(blockEnd, 16);
            String value = buf.toString();
            xmlSink.sinkSimpleNode(nodeName, value);
        }
        xmlSink.closeNode();
        return xmlSink.toString();
    }
}
